#ifndef EMPLOYEE_H
#define EMPLOYEE_H

/*
 ******************************
 * Object Oriented Programming in C
 *
 * Author: Laurent Deniau, Laurent.Deniau@cern.ch
 *
 * For more information, please see the paper:
 * http://home.cern.ch/ldeniau/html/oopc/oopc.html
 *
 ******************************
 */

#include <person.h>

/*------------------------*/
/*   employee interface   */
/*   derive from person   */
/*------------------------*/

#undef  OBJECT
#define OBJECT employee

/* Object interface */
OBJECT_INTERFACE

  INHERIT_MEMBERS_OF (person);
  char const* private(department);

OBJECT_METHODS

  INHERIT_METHODS_OF (person);

ENDOF_INTERFACE

/* Class interface */
CLASS_INTERFACE

  t_employee*const classMethod_(new)
     char const name[], char const department[] __;
  void method_(init) char const name[], char const department[] __;
  void method_(copy) t_employee const*const emp __;

ENDOF_INTERFACE

#endif
