#ifndef EXAMPLE_H
#define EXAMPLE_H

/*
 ******************************
 * Object Oriented Programming in C
 *
 * Author: Laurent Deniau, Laurent.Deniau@cern.ch
 *
 * For more information, please see the paper:
 * http://home.cern.ch/ldeniau/html/oopc/oopc.html
 *
 ******************************
 */

/*
  Example of inheritance in C++:
  K --> J --> F
          --> G --> C --> A
                      --> B
          --> H --> D
                --> E --> B
          --> I
*/

class A {
public:
  virtual ~A() {}
};

class B {
public:
  virtual ~B() {}
};

class C : public A, public B {
public:
  virtual ~C() {}
};

class D {
public:
  virtual ~D() {}
};

class E : public B {
public:
  virtual ~E() {}
};

class F {
public:
  virtual ~F() {}
};

class G : public C {
public:
  virtual ~G() {}
};

class H : public D, public E {
public:
  virtual ~H() {}
};

class I {
public:
  virtual ~I() {}
};

class J : public F, public G, public H, public I {
public:
  virtual ~J() {}
};

class K : public J {
public:
  virtual ~K() {}
};

#endif
