/*
 ******************************
 * Object Oriented Programming in C
 *
 * Author: Laurent Deniau, Laurent.Deniau@cern.ch
 *
 * For more information, please see the paper:
 * http://home.cern.ch/ldeniau/html/oopc/oopc.html
 *
 ******************************
 */

#include <iostream>
#include <manager.H>

/* polymorphism example */
void print_person(Person const *p)
{
  p->print();
}

int
main(void)
{
  Person   *per = new Person  ("Brown");
  Employee *emp = new Employee("Smith", "Cars");
  Manager  *mng = new Manager ("Collins", "Trucks", "PhD @ CMU", 2);

  cout << "\nList of persons:" << endl;
  print_person(per);
  print_person(emp);
  print_person(mng);

  cout << "\nSize of objects:"   << endl;
  cout << "sizeof(Manager)   = " << sizeof(Manager)   << endl;
  cout << "sizeof(Employee)  = " << sizeof(Employee)  << endl;
  cout << "sizeof(Person)    = " << sizeof(Person)    << endl;
  cout << "sizeof(Education) = " << sizeof(Education) << endl;

  delete per;
  delete emp;
  delete mng;

  return EXIT_SUCCESS;
}
